# coding: utf-8

"""
    Klaviyo API

    The Klaviyo REST API. Please visit https://developers.klaviyo.com for more details.

    The version of the OpenAPI document: 2023-10-15
    Contact: developers@klaviyo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator

class CouponCodeUpdateQueryResourceObjectAttributes(BaseModel):
    """
    CouponCodeUpdateQueryResourceObjectAttributes
    """
    status: Optional[StrictStr] = Field(None, description="The API status of our coupon codes.")
    expires_at: Optional[datetime] = Field(None, description="The datetime when this coupon code will expire. If not specified or set to null, it will be automatically set to 1 year.")
    __properties = ["status", "expires_at"]

    @validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('ASSIGNED_TO_PROFILE', 'DELETING', 'PROCESSING', 'UNASSIGNED', 'VERSION_NOT_ACTIVE'):
            raise ValueError("must be one of enum values ('ASSIGNED_TO_PROFILE', 'DELETING', 'PROCESSING', 'UNASSIGNED', 'VERSION_NOT_ACTIVE')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CouponCodeUpdateQueryResourceObjectAttributes:
        """Create an instance of CouponCodeUpdateQueryResourceObjectAttributes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if status (nullable) is None
        # and __fields_set__ contains the field
        if self.status is None and "status" in self.__fields_set__:
            _dict['status'] = None

        # set to None if expires_at (nullable) is None
        # and __fields_set__ contains the field
        if self.expires_at is None and "expires_at" in self.__fields_set__:
            _dict['expires_at'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CouponCodeUpdateQueryResourceObjectAttributes:
        """Create an instance of CouponCodeUpdateQueryResourceObjectAttributes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CouponCodeUpdateQueryResourceObjectAttributes.parse_obj(obj)

        _obj = CouponCodeUpdateQueryResourceObjectAttributes.parse_obj({
            "status": obj.get("status"),
            "expires_at": obj.get("expires_at")
        })
        return _obj


