# coding: utf-8

"""
    Klaviyo API

    The Klaviyo REST API. Please visit https://developers.klaviyo.com for more details.

    The version of the OpenAPI document: 2023-10-15
    Contact: developers@klaviyo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr
from openapi_client.models.catalog_variant_enum import CatalogVariantEnum

class ServerBISSubscriptionCreateQueryResourceObjectRelationshipsVariantData(BaseModel):
    """
    ServerBISSubscriptionCreateQueryResourceObjectRelationshipsVariantData
    """
    type: CatalogVariantEnum = Field(...)
    id: StrictStr = Field(..., description="The catalog variant ID for which the profile is subscribing to back in stock notifications. This ID is made up of the integration type, catalog ID, and and the external ID of the variant like so: `integrationType:::catalogId:::externalId`. If the integration you are using is not set up for multi-catalog storage, the 'catalogId' will be `$default`. For Shopify `$shopify:::$default:::33001893429341`")
    __properties = ["type", "id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ServerBISSubscriptionCreateQueryResourceObjectRelationshipsVariantData:
        """Create an instance of ServerBISSubscriptionCreateQueryResourceObjectRelationshipsVariantData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ServerBISSubscriptionCreateQueryResourceObjectRelationshipsVariantData:
        """Create an instance of ServerBISSubscriptionCreateQueryResourceObjectRelationshipsVariantData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ServerBISSubscriptionCreateQueryResourceObjectRelationshipsVariantData.parse_obj(obj)

        _obj = ServerBISSubscriptionCreateQueryResourceObjectRelationshipsVariantData.parse_obj({
            "type": obj.get("type"),
            "id": obj.get("id")
        })
        return _obj


